/******************************************************************************
 * Product: Adempiere ERP & CRM Smart Business Solution                       *
 * Copyright (C) 1999-2006 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software; you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY; without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program; if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 2620 Augustine Dr. #245, Santa Clara, CA 95054, USA        *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/

/**
 * 2007, Modified by Posterita Ltd.
 */

package org.fina.form;

import java.math.BigDecimal;
//import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
//import java.sql.Statement;
//import java.util.StringTokenizer;
//import java.util.logging.*;
//import java.util.logging.Logger;

import org.adempiere.webui.component.Button;
import org.adempiere.webui.component.Combobox;
import org.adempiere.webui.component.Grid;
import org.adempiere.webui.component.Label;
import org.adempiere.webui.component.Row;
import org.adempiere.webui.component.Rows;
import org.adempiere.webui.component.Textbox;
import org.adempiere.webui.panel.ADForm;
//import org.adempiere.webui.theme.ThemeManager;
import org.compiere.model.MOrder;
import org.compiere.model.MOrderLine;
//import org.compiere.model.PO;
//import org.compiere.util.CLogger;
import org.compiere.util.DB;
import org.compiere.util.Env;
//import org.compiere.util.KeyNamePair;
import org.compiere.util.Msg;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.Events;
import org.zkoss.zul.Decimalbox;
import org.zkoss.zul.ListModel;
import org.zkoss.zul.SimpleListModel;


/**
 * A Custom Form to Fast Input SO Lines.
 * //    OrderLine
 *
 * @author Peter Shepetko
 *
 */
public class QuickInputOrderLine extends ADForm implements EventListener<Event>
{
    /**
	 * 
	 */
	private static final long serialVersionUID = -2038792517003449189L;
	

    /** Grid used to layout components. */
    private Grid m_grdMain = new Grid();
    
	private Label productLabel = new Label(Msg.translate(Env.getCtx(), "M_Product_ID"));
	private Combobox productField = new Combobox();

//	private Label productQtyLabel = new Label(Msg.translate(Env.getCtx(), "Qty"));
	private Decimalbox productQtyField = new Decimalbox();
	
    /** Process button. */
//    private Button m_btnSql = createProcessButton();

    private Textbox m_txbResultField = new Textbox();
	private int p_AD_Client_ID= Env.getAD_Client_ID(Env.getCtx());
	private int p_AD_Org_ID= Env.getAD_Org_ID(Env.getCtx());
//	private int p_AD_User_ID= Env.getAD_User_ID(Env.getCtx());
//	private int p_AD_Role_ID= Env.getAD_Role_ID(Env.getCtx());
	private int p_M_Order_ID=(Env.getContextAsInt(Env.getCtx(), "M_Order_ID"));

    @Override
    protected void initForm()
    {
           	
    	Row rwTop = new Row();
        Row rwBottom = new Row();
        Rows rows = new Rows();
        final int noColumns = 120;
        final int maxStatementLength = 9000;
        final int noStatementRows = 5;
        final int noResultRows = 20;

        m_grdMain.setWidth("80%");
        
		productField = new Combobox();
		String[] _dict =null;
				//start select	
				int i = 1;
				String sql = "SELECT name, value, m_product_id FROM adempiere.m_product where isactive='Y' and ad_client_id="+p_AD_Client_ID;
				PreparedStatement pstmt = null;
				ResultSet rs = null;
				try
				{
					pstmt = DB.prepareStatement(sql, null);
					rs = pstmt.executeQuery();
					_dict = new String[_getcountproduct()+1];
					while (rs.next())
					{
						_dict[i] = rs.getString(1)+" <"+rs.getInt(3)+">";
						i++;
					}
				}
				catch (SQLException e)
				{
//					log.log(Level.SEVERE, sql, e);
				}
				finally
				{
					DB.close(rs, pstmt);
					rs = null; pstmt = null;
				}	//end select		

		ListModel dictModel= new SimpleListModel(_dict);
		productField.setModel(dictModel);
        
		 productField.setAutodrop(true);
		 productField.setAutocomplete(true);
		 productField.setButtonVisible(true);
		 productField.addEventListener(Events.ON_CHANGE, this);
		 productField.addEventListener(Events.ON_OK, this);
//		 productField.addEventListener(Events.ON_SELECT, this);
        
        rwTop.appendChild(productLabel);
        rwTop.appendChild(productField);

        
//        rwTop.appendChild(productQtyLabel);
        rwTop.appendChild(productQtyField);
        productQtyField.addEventListener(Events.ON_OK, this);
		
//        rwTop.appendChild(m_btnSql);

        rows.appendChild(rwTop);

        // create the bottom row of components
        m_txbResultField.setCols(noColumns);
        m_txbResultField.setRows(noResultRows);
        m_txbResultField.setReadonly(true);

        rwBottom.appendCellChild(m_txbResultField, 3);
        rwBottom.setAlign("center");

        rows.appendChild(rwBottom);

        // put it all together
        m_grdMain.appendChild(rows);

        this.appendChild(m_grdMain);
        return;
    }

    /**
     *  Create Process Button.
     *  @return button
     */
    public static final Button createProcessButton()
    {
        Button btnProcess = new Button();

//        btnProcess.setImage(ThemeManager.getThemeResource("images/Process24.png"));
        btnProcess.setName(Msg.getMsg(Env.getCtx(), "Save"));
        btnProcess.setLabel(Msg.getMsg(Env.getCtx(), "Save"));
        return btnProcess;
    }   //  createProcessButton



    /*
     * (non-Javadoc)
     * @see org.adempiere.webui.panel.ADForm#onEvent(org.zkoss.zk.ui.event.Event)
     */
    public void onEvent(Event event) throws Exception
    {
    	String str_product=null;
    	String str_zn1 = "<";
    	String str_zn2 = ">";
    	BigDecimal _d_empty=null;
    	if (event.getTarget() == productField)
		 	{
//   		if (productField.getSelectedIndex() != 0)
			productQtyField.focus();
    		productQtyField.setValue(_d_empty);
			}
    	else if (event.getTarget() == productQtyField)
	 	{  	
    	if (productQtyField.getValue() != null)

		m_txbResultField.setValue(m_txbResultField.getValue()+"+Product:<"+productField.getValue()+" Qty: "+productQtyField.getValue()+" . \n");

    	str_product=productField.getValue().substring(productField.getValue().indexOf(str_zn1)+1,productField.getValue().indexOf(str_zn2));
		System.out.println("str_product="+str_product);
    	newOrderLine(Integer.parseInt(str_product),productQtyField.getValue());
    	productField.focus();
		productField.setValue(null);
	 	}
    }
    
	/**
	 *	Get Count Products
	 * @return 
	 */
	public Integer _getcountproduct()
	{
					int _count=0;
					String sql_count = "SELECT count(*) FROM adempiere.m_product where isactive='Y' and ad_client_id="+p_AD_Client_ID;
					PreparedStatement pstmt_count = null;
					ResultSet rs_count = null;
					try
					{
						pstmt_count = DB.prepareStatement(sql_count, null);
						rs_count = pstmt_count.executeQuery();
						if (rs_count.next())
						{
							_count=rs_count.getInt (1);
						}
					}
					catch (SQLException e)
					{
// 						log.log(Level.SEVERE, sql_count, e);
						return 0;
					}
					finally
					{
						DB.close(rs_count, pstmt_count);
						rs_count = null; pstmt_count = null;
					}
				return _count;		
	}
	
	/**
	 * 	Add Order Line 
	 *	@param this Order 
	 *	@return number of lines copied
	 */
	public void newOrderLine (int _m_product_id, BigDecimal _QtyEntered)

	{
		MOrder order = new MOrder (Env.getCtx(), 1000005, null);
		
		System.out.println("order.getDocumentNo="+order.getDocumentNo());
			MOrderLine line = new MOrderLine (order);
			line.setC_Order_ID(1000005);// C_Order_ID
			line.setAD_Org_ID(11);
			line.setM_Product_ID(_m_product_id);
			line.setQtyDelivered(Env.ZERO);
			line.setQtyInvoiced(Env.ZERO);
			line.setQtyReserved(Env.ZERO);
			line.setDateDelivered(null);
			line.setDateInvoiced(null);
			line.setQtyEntered(_QtyEntered);//Palich
        	line.setM_AttributeSetInstance_ID(0);//Palich
        	line.setPriceEntered(line.getPriceActual());

        	line.save();
	}	//	copyOneLineFrom for Palich GTD
	   
}
